// ---------------------------------------------------------------------------
//
// frmMain(GeldAutomat.PAS/DFM)                         Ulrich Mller 25.12.01
//                                                      Procida 400NT  Delphi4
// GeldAutomat : Ausgabe von Mnzbetrgen (aus Profi Computing 1991)
//
// ---------------------------------------------------------------------------

unit GeldAutoBetrag;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FishFa50, StdCtrls;

type
  TfrmMain = class(TForm)
    lblBetrag: TLabel;
    txtBetrag: TEdit;
    lblTitel: TLabel;
    cmdAction: TButton;
    cmdEnde: TButton;
    cboPortName: TComboBox;
    lblStatus: TLabel;
    procedure Home();
    procedure Schieber(Anzahl: Integer);
    procedure cmdActionClick(Sender: TObject);
    procedure cmdEndeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

const
  mSchieber = 1; mSchlitten = 2;
  eSchieberHinten = 1; eSchieberVorn = 2;
  eSchlittenEnde = 3; eSchlittenImpuls = 4;
var
  ft: TFishFace;

procedure Stueckelung(Betrag: Integer; out Z200, Z100, Z50: Integer);
begin
  Z200 := 0;
  while Betrag - 200 >= 0 do begin
    Dec(Betrag, 200);
    Inc(Z200);
    end;

  Z100 := 0;
  while Betrag - 100 >= 0 do begin
    Dec(Betrag, 100);
    Inc(Z100);
    end;

  Z50 := 0;
  while Betrag - 50 >= 0 do begin
    Dec(Betrag, 50);
    Inc(Z50);
    end;
end;

procedure TfrmMain.Home();
begin
  lblStatus.Caption := 'Home';
  ft.SetMotor(mSchieber, ftiRechts);
  ft.WaitForInput(eSchieberHinten, False);
  ft.SetMotor(mSchieber, ftiAus);
  ft.SetMotor(mSchlitten, ftiLinks);
  ft.WaitForInput(eSchlittenEnde, True);
  ft.SetMotor(mSchlitten, ftiAus);
end;

procedure TfrmMain.Schieber(Anzahl: Integer);
var i: Integer;
begin
  lblStatus.Caption := 'Mnzausgabe';
  for i := 1 to Anzahl do begin
    ft.SetMotor(mSchieber, ftiLinks);
    ft.WaitForInput(eSchieberVorn, False);
    ft.SetMotor(mSchieber, ftiRechts);
    ft.WaitForInput(eSchieberHinten, False);
    ft.SetMotor(mSchieber, ftiAus);
    end;
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
var Z200, Z100, Z50: Integer;
begin

  if ft.OpenInterface(cboPortName.Text) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;

  Home;

  Stueckelung(StrToInt(txtBetrag.Text), Z200, Z100, Z50);

  lblStatus.Caption := 'Schacht Rechts';
  ft.SetMotor(mSchlitten, ftiRechts);
  ft.WaitForChange(eSchlittenImpuls, 20);
  ft.SetMotor(mSchlitten, ftiAus);
  Schieber(Z200);

  lblStatus.Caption := 'Schacht Mitte';
  ft.SetMotor(mSchlitten, ftiRechts);
  ft.WaitForChange(eSchlittenImpuls, 70);
  ft.SetMotor(mSchlitten, ftiAus);
  Schieber(Z100);

  lblStatus.Caption := 'Schacht Links';
  ft.SetMotor(mSchlitten, ftiRechts);
  ft.WaitForChange(eSchlittenImpuls, 70);
  ft.SetMotor(mSchlitten, ftiAus);
  Schieber(Z50);

  ft.CloseInterface;
  lblStatus.Caption := '---Finis---';
  cmdEnde.SetFocus;

end;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  ft := TFishFace.Create;
  cboPortName.ItemIndex := 4;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ft.Free;
end;

end.
